#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif


uniform float u_testadd;
uniform mat4 u_addMat;
uniform float u_time;
uniform float u_round;
///////////////////////////////////////////////////////////
// Variables
vec4 _baseColor;
uniform sampler2D u_diffuseTexture;
uniform vec2 resolution;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;
varying vec4 v_color;


void main(void) {
    float ExCnt=clamp(u_time/30.0,0.0,1.0);//JE^̏ݒƐK
    float efix = step(1.0-v_texCoord.y,ExCnt);

    
    //łڂ
    vec3 col = texture2D(u_diffuseTexture, v_texCoord).rgb;
    vec3 eCol;
    vec2 ofs=1.0/resolution;
    eCol=col;
    eCol+=1.0 *texture2D(u_diffuseTexture, v_texCoord+vec2( 1.0, 0.0)*ofs).rgb;
    eCol+=1.0 *texture2D(u_diffuseTexture, v_texCoord+vec2( 0.0, 1.0)*ofs).rgb;
    eCol+=1.0 *texture2D(u_diffuseTexture, v_texCoord+vec2(-1.0, 0.0)*ofs).rgb;
    eCol+=1.0 *texture2D(u_diffuseTexture, v_texCoord+vec2( 0.0,-1.0)*ofs).rgb;
    
    eCol+=0.75*texture2D(u_diffuseTexture, v_texCoord+vec2( 1.0, 1.0)*ofs).rgb;
    eCol+=0.75*texture2D(u_diffuseTexture, v_texCoord+vec2( 1.0,-1.0)*ofs).rgb;
    eCol+=0.75*texture2D(u_diffuseTexture, v_texCoord+vec2(-1.0,-1.0)*ofs).rgb;
    eCol+=0.75*texture2D(u_diffuseTexture, v_texCoord+vec2(-1.0, 0.0)*ofs).rgb;
    
    eCol+=0.5 *texture2D(u_diffuseTexture, v_texCoord+vec2( 2.0, 0.0)*ofs).rgb;
    eCol+=0.5 *texture2D(u_diffuseTexture, v_texCoord+vec2( 0.0, 2.0)*ofs).rgb;
    eCol+=0.5 *texture2D(u_diffuseTexture, v_texCoord+vec2(-2.0, 0.0)*ofs).rgb;
    eCol+=0.5 *texture2D(u_diffuseTexture, v_texCoord+vec2( 0.0,-2.0)*ofs).rgb;
    eCol/=10.0;

    col=(1.0-efix)*col+efix*eCol;

    //0-0.5ŃOXP
    //eCol=col.r*0.21+col.g*0.72+col.b*0.07;
    float fcol=col.r*0.21+col.g*0.72+col.b*0.07;
    col=(1.0-efix)*col+efix*eCol*0.5;

    gl_FragColor = vec4(col,1.0);
    //gl_FragColor = vec4(uv,0.0,1.0);
}