#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

const float wdt = 0.2;

//𐶐
float rnd(float p,float a){
    return fract(sin(dot(vec2(p,floor(u_time*0.3+a)),vec2(12.9898,78.233))) * 43758.5453);
}
//Ԃ𐶐(̓[v\Ƃ邽߂ɍőlo^)
float irnd(float p,float M,float a){
    float i = mod(ceil(p),M);
    float f = mod(floor(p),M);
    float ri = rnd(i,a);
    float rf = rnd(f,a);
    return rf + (ri-rf)*fract(p);
}

void main()
{
    vec2 uv=v_texCoord;
    uv.x=uv.x*2.0-1.0;
    float wdt;
    float FO;

    //````(3*60FRM)@A120FRM͒ǐ
    vec3 CHCol;
    FO = clamp(1.0-(u_time-150.0)/30.0,0.0,1.0);
    wdt=0.2*FO;
    vec3 col[3];
    col[0]=vec3(0.5,0.8,0.8);
    col[1]=vec3(0.8,0.8,0.5);
    col[2]=vec3(-0.8,-0.8,-0.8);
    float d[3];
    for(float i=0.0;i<3.0;i++){
        d[int(i)]=clamp(1.0-(30.0+30*step(u_time,120))*abs(wdt*(irnd(uv.y*100.0,100.0,i)-0.5)-uv.x),0.0,1.0);
        CHCol+=d[int(i)]*col[int(i)]*FO;
    }
    CHCol*=step(u_time,180.0);
    CHCol*=vec3(1.0,1.0,1.0)+vec3(0.0,-0.7,-0.7)*step(u_time,120);

    //M[(5*60FRM)
    FO=clamp(1.0-(u_time-450.0)/30.0,0.0,1.0);
    vec3 GYCol;
    wdt=0.8+(sin(u_time*0.5)+1.0)*0.1*0.45;
    wdt*=FO;
    GYCol+=vec3(0.6,0.6,0.2)*clamp(clamp(wdt-abs(uv.x),0.0,1.0)*10.0,0.0,1.0);
    wdt=0.6+(sin(u_time*0.4)+1.0)*0.3*0.45;
    wdt*=FO;
    GYCol+=vec3(0.4,0.4,0.1)*clamp(clamp(wdt-abs(uv.x),0.0,1.0)*10.0,0.0,1.0);
    GYCol+=vec3(0.5,0.3,0.3)*clamp((1.0-abs(uv.x))*4.0,0.0,1.0);
    vec3 GYColB=GYCol;

    float y;
    y=mod(u_time*0.21,3.5)-1.0;
    y+=0.1*irnd(uv.x*20.0,20.0,0.0);
    GYCol=GYCol*0.8+GYCol*vec3(1.0,0.5,1.0)*0.5*
        min(1.0-clamp((y-uv.y)*1.2,0.0,1.0) , 1.0-clamp((uv.y-y)*10.2,0.0,1.0)) ;
    y=mod(u_time*0.52,5.5)-1.0;
    y+=0.1*irnd(uv.x*20.0,20.0,1.0);
    GYCol=GYCol*0.8+GYCol*vec3(1.0,1.0,0.5)*0.5*
        min(1.0-clamp((y-uv.y)*1.2,0.0,1.0) , 1.0-clamp((uv.y-y)*10.2,0.0,1.0)) ;
    y=mod(u_time*0.43,7.5)-1.0;
    y+=0.1*irnd(uv.x*20.0,20.0,2.0);
    GYCol=GYCol*0.8-GYCol*vec3(1.0,0.7,0.7)*0.5*
        min(1.0-clamp((y-uv.y)*1.2,0.0,1.0) , 1.0-clamp((uv.y-y)*10.2,0.0,1.0)) ;
    GYCol-=GYCol*GYColB*vec3(0.1,0.5,0.8);
    GYCol*=step(180.0,u_time)*step(u_time,180.0+300.0);

    gl_FragColor = vec4(CHCol+GYCol,1.0);
}