#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif


uniform float u_time;
///////////////////////////////////////////////////////////
// Variables
uniform sampler2D u_diffuseTexture;
uniform vec2 resolution;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;


void main(void) {
    float ExCnt=clamp(u_time/60.0,0.0,1.0);//JE^̏ݒƐK
    
    //0.5-1.0ł炵
    float efix=clamp((ExCnt-0.5)*2.0,0.0,1.0);
    vec2 pos = v_texCoord + vec2(1.0,2.0)*0.1*(mod(floor((v_texCoord.x-0.5*v_texCoord.y)*5.0),2.0)*2.0-1.0) * efix;

    //0-0.5łڂ
    efix = clamp(ExCnt*2.0,0.0,1.0);
    vec3 col = texture2D(u_diffuseTexture, pos).rgb;
    vec2 ofs=1.0/resolution;
    vec3 eCol;
    eCol=col;
    eCol+=1.0 *texture2D(u_diffuseTexture, pos+vec2( 1.0, 0.0)*ofs).rgb;
    eCol+=1.0 *texture2D(u_diffuseTexture, pos+vec2( 0.0, 1.0)*ofs).rgb;
    eCol+=1.0 *texture2D(u_diffuseTexture, pos+vec2(-1.0, 0.0)*ofs).rgb;
    eCol+=1.0 *texture2D(u_diffuseTexture, pos+vec2( 0.0,-1.0)*ofs).rgb;
    
    eCol+=0.75*texture2D(u_diffuseTexture, pos+vec2( 1.0, 1.0)*ofs).rgb;
    eCol+=0.75*texture2D(u_diffuseTexture, pos+vec2( 1.0,-1.0)*ofs).rgb;
    eCol+=0.75*texture2D(u_diffuseTexture, pos+vec2(-1.0,-1.0)*ofs).rgb;
    eCol+=0.75*texture2D(u_diffuseTexture, pos+vec2(-1.0, 0.0)*ofs).rgb;
    
    eCol+=0.5 *texture2D(u_diffuseTexture, pos+vec2( 2.0, 0.0)*ofs).rgb;
    eCol+=0.5 *texture2D(u_diffuseTexture, pos+vec2( 0.0, 2.0)*ofs).rgb;
    eCol+=0.5 *texture2D(u_diffuseTexture, pos+vec2(-2.0, 0.0)*ofs).rgb;
    eCol+=0.5 *texture2D(u_diffuseTexture, pos+vec2( 0.0,-2.0)*ofs).rgb;
    eCol/=10.0;

    col=(1.0-efix)*col+efix*eCol;

    //0-0.5ŃOXP
    //eCol=col.r*0.21+col.g*0.72+col.b*0.07;
    float fcol=col.r*0.21+col.g*0.72+col.b*0.07;
    col=(1.0-efix)*col+fcol*efix*1.5;

    gl_FragColor = vec4(col,1.0);
}